"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.startListener = void 0;
const const_1 = require("../../const");
const utils_1 = require("../../helpers/utils");
function startListener(clientEvents, controller, homeAssistant, node) {
    clientEvents.addListener('ha_client:ready', controller.onStateChanged.bind(controller));
    clientEvents.addListener(`ha_events:state_changed:${node.config.entityId}`, controller.onStateChanged.bind(controller));
    if (node.config.offsetType === const_1.TypedInputTypes.JSONata &&
        node.config.offset.length > 12) {
        const ids = (0, utils_1.getEntitiesFromJsonata)(node.config.offset);
        ids.forEach((id) => {
            clientEvents.addListener(`ha_events:state_changed:${id}`, controller.onStateChanged.bind(controller));
        });
    }
    if (homeAssistant.isHomeAssistantRunning) {
        clientEvents.emit(`ha_events:state_changed:${node.config.entityId}`);
    }
}
exports.startListener = startListener;
