"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStateChangeEvents = void 0;
const homeAssistant_1 = require("../../homeAssistant");
function createStateChangeEvents(homeAssistant) {
    const entities = homeAssistant.websocket.getStates();
    const events = [];
    for (const entityId in entities) {
        events.push({
            event_type: homeAssistant_1.HaEvent.StateChanged,
            entity_id: entityId,
            event: {
                entity_id: entityId,
                old_state: entities[entityId],
                new_state: entities[entityId],
            },
        });
    }
    return events;
}
exports.createStateChangeEvents = createStateChangeEvents;
